> This page is for version v2026.01.16-dev.
> For other versions, use one of these documentation indexes:
> - latest (default): https://docs.machanirobotics.dev/latest/llms.txt
> - v2026.01.16-dev: https://docs.machanirobotics.dev/v-2026-01-16-dev/llms.txt

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.machanirobotics.dev/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.machanirobotics.dev/_mcp/server.

# Publish Message

POST https://api.machanirobotics.com/v1/conversation/sessions/sessions/{session}:message
Content-Type: application/json

PublishMessage sends a message to an active session.

Use this method for a user to contribute a message to the session.

Request: PublishMessageRequest (specify session name, username, and message)
Response: PublishMessageResponse (acknowledgement of published message)

HTTP: POST /v1/conversation/sessions/\{name}/messages

Reference: https://docs.machanirobotics.dev/v-2026-01-16-dev/2026-01-16-dev/latest/session-service/publishmessage

## Request

### Path parameters

- `session` (string, required) — The session id.

### Body (application/json)

This endpoint expects a PublishMessageRequest.

- `name` (string, required) — name of the user publishing the message.
- `session` (string, required) — Session is the session object to join.
- `message` (PublishMessage, required) — Message is the message to be published in the session.

## Response

### 200

OK

- `acknowledgment` (PublishMessageACK, required) — Acknowledgment is the acknowledgment message for the published message.
- `message` (PublishMessage, required) — Message is the original message that was published.

## Errors

### 400 Bad Request Error

Bad Request

- `code` (integer, optional) — The status code, which should be an enum value of [google.rpc.Code][google.rpc.Code].
- `message` (string, optional) — A developer-facing error message, which should be in English. Any user-facing error message should be localized and sent in the [google.rpc.Status.details][google.rpc.Status.details] field, or localized by the client.
- `details` (list of GoogleProtobufAny, optional) — A list of messages that carry the error details. There is a common set of message types for APIs to use.

## Types

### PublishMessage

Publish Message defines the structure for publishing messages to a session channel. It includes the channel to publish to, the message content, and optional data.

- `channel` (integer, required) — Channel is the channel to which the message is published.
- `message` (string, required) — Message is the content of the message being published.
- `data` (PublishMessageData, optional) — Data is optional additional data associated with the message.

### PublishMessageACK

PublishMessageACK is the acknowledgment message for a successfully published message to a Session.

- `stream` (string, required) — Stream is the stream name to which the message was published.
- `sequence` (string, required) — Sequence is the sequence number of the message in the stream.
- `duplicate` (boolean, optional) — Duplicate indicates whether the message was a duplicate. This can be detected using the MsgIDHeader and StreamConfig.Duplicates.
- `domain` (string, optional) — Domain is the domain to which the message was published.

### GoogleProtobufAny

Contains an arbitrary serialized message along with a @type that describes the type of the serialized message.

- `@type` (string, optional) — The type of the serialized message.

### PublishMessageData

Data is optional additional data associated with the message.

## Examples

**Request**

```json
{
  "name": "session-12345",
  "session": "user-67890",
  "message": {
    "channel": 2,
    "message": "Hello, is the robot ready for the next task?"
  }
}
```

**Response**

```json
{
  "acknowledgment": {
    "stream": "stream-abcde",
    "sequence": "seq-0001",
    "duplicate": false,
    "domain": "machanirobotics.com"
  },
  "message": {
    "channel": 2,
    "message": "Message received and queued for processing.",
    "data": {}
  }
}
```

**SDK Code**

```python
import requests

url = "https://api.machanirobotics.com/v1/conversation/sessions/sessions/session:message"

payload = {
    "name": "session-12345",
    "session": "user-67890",
    "message": {
        "channel": 2,
        "message": "Hello, is the robot ready for the next task?"
    }
}
headers = {"Content-Type": "application/json"}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.machanirobotics.com/v1/conversation/sessions/sessions/session:message';
const options = {
  method: 'POST',
  headers: {'Content-Type': 'application/json'},
  body: '{"name":"session-12345","session":"user-67890","message":{"channel":2,"message":"Hello, is the robot ready for the next task?"}}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.machanirobotics.com/v1/conversation/sessions/sessions/session:message"

	payload := strings.NewReader("{\n  \"name\": \"session-12345\",\n  \"session\": \"user-67890\",\n  \"message\": {\n    \"channel\": 2,\n    \"message\": \"Hello, is the robot ready for the next task?\"\n  }\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.machanirobotics.com/v1/conversation/sessions/sessions/session:message")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Content-Type"] = 'application/json'
request.body = "{\n  \"name\": \"session-12345\",\n  \"session\": \"user-67890\",\n  \"message\": {\n    \"channel\": 2,\n    \"message\": \"Hello, is the robot ready for the next task?\"\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.machanirobotics.com/v1/conversation/sessions/sessions/session:message")
  .header("Content-Type", "application/json")
  .body("{\n  \"name\": \"session-12345\",\n  \"session\": \"user-67890\",\n  \"message\": {\n    \"channel\": 2,\n    \"message\": \"Hello, is the robot ready for the next task?\"\n  }\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.machanirobotics.com/v1/conversation/sessions/sessions/session:message', [
  'body' => '{
  "name": "session-12345",
  "session": "user-67890",
  "message": {
    "channel": 2,
    "message": "Hello, is the robot ready for the next task?"
  }
}',
  'headers' => [
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.machanirobotics.com/v1/conversation/sessions/sessions/session:message");
var request = new RestRequest(Method.POST);
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"name\": \"session-12345\",\n  \"session\": \"user-67890\",\n  \"message\": {\n    \"channel\": 2,\n    \"message\": \"Hello, is the robot ready for the next task?\"\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Content-Type": "application/json"]
let parameters = [
  "name": "session-12345",
  "session": "user-67890",
  "message": [
    "channel": 2,
    "message": "Hello, is the robot ready for the next task?"
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.machanirobotics.com/v1/conversation/sessions/sessions/session:message")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```